@@ -504,7 +505,7 @@ and then processing continues with remaining flags from the command
line.
-
+
In addition to accessing FLAGS_foo
directly, it is
possible to access the flags programmatically, through an API. It is
diff --git a/packages/deb/changelog b/packages/deb/changelog
index 9ff43dd..abae5a6 100644
--- a/packages/deb/changelog
+++ b/packages/deb/changelog
@@ -1,3 +1,9 @@
+gflags (1.5-1) unstable; urgency=low
+
+ * New upstream release.
+
+ -- Google Inc. Mon, 24 Jan 2011 16:11:35 -0800
+
gflags (1.4-2) unstable; urgency=low
* Accidentally uploaded an outdated .deb to Google Code; this is the right one
diff --git a/src/gflags/gflags.h.in b/src/gflags/gflags.h.in
index 22b41ec..e70f026 100644
--- a/src/gflags/gflags.h.in
+++ b/src/gflags/gflags.h.in
@@ -347,7 +347,8 @@ extern void SetUsageMessage(const std::string& usage);
// Looks for flags in argv and parses them. Rearranges argv to put
// flags first, or removes them entirely if remove_flags is true.
// If a flag is defined more than once in the command line or flag
-// file, the last definition is used.
+// file, the last definition is used. Returns the index (into argv)
+// of the first non-flag argument.
// See top-of-file for more details on this function.
#ifndef SWIG // In swig, use ParseCommandLineFlagsScript() instead.
extern uint32 ParseCommandLineFlags(int *argc, char*** argv,
@@ -361,9 +362,10 @@ extern uint32 ParseCommandLineFlags(int *argc, char*** argv,
// changing default values for some FLAGS (via
// e.g. SetCommandLineOptionWithMode calls) between the time of
// command line parsing and the time of dumping help information for
-// the flags as a result of command line parsing.
-// If a flag is defined more than once in the command line or flag
-// file, the last definition is used.
+// the flags as a result of command line parsing. If a flag is
+// defined more than once in the command line or flag file, the last
+// definition is used. Returns the index (into argv) of the first
+// non-flag argument. (If remove_flags is true, will always return 1.)
extern uint32 ParseCommandLineNonHelpFlags(int *argc, char*** argv,
bool remove_flags);
// This is actually defined in commandlineflags_reporting.cc.
@@ -377,12 +379,14 @@ extern void HandleCommandLineHelpFlags(); // in commandlineflags_reporting.cc
// are spawned.
extern void AllowCommandLineReparsing();
-// Reparse the flags that have not yet been recognized.
-// Only flags registered since the last parse will be recognized.
-// Any flag value must be provided as part of the argument using "=",
-// not as a separate command line argument that follows the flag argument.
+// Reparse the flags that have not yet been recognized. Only flags
+// registered since the last parse will be recognized. Any flag value
+// must be provided as part of the argument using "=", not as a
+// separate command line argument that follows the flag argument.
// Intended for handling flags from dynamically loaded libraries,
// since their flags are not registered until they are loaded.
+// Returns the index (into the original argv) of the first non-flag
+// argument. (If remove_flags is true, will always return 1.)
extern uint32 ReparseCommandLineNonHelpFlags();
// Clean up memory allocated by flags. This is only needed to reduce
@@ -455,7 +459,7 @@ extern const char kStrippedFlagHelp[];
#if defined(STRIP_FLAG_HELP) && STRIP_FLAG_HELP > 0
// Need this construct to avoid the 'defined but not used' warning.
-#define MAYBE_STRIPPED_HELP(txt) (false ? (txt) : kStrippedFlagHelp)
+#define MAYBE_STRIPPED_HELP(txt) (false ? (txt) : @ac_google_namespace@::kStrippedFlagHelp)
#else
#define MAYBE_STRIPPED_HELP(txt) txt
#endif
diff --git a/src/gflags_strip_flags_test.cc b/src/gflags_strip_flags_test.cc
new file mode 100644
index 0000000..77234e2
--- /dev/null
+++ b/src/gflags_strip_flags_test.cc
@@ -0,0 +1,58 @@
+// Copyright (c) 2011, Google Inc.
+// All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+//
+// * Redistributions of source code must retain the above copyright
+// notice, this list of conditions and the following disclaimer.
+// * Redistributions in binary form must reproduce the above
+// copyright notice, this list of conditions and the following disclaimer
+// in the documentation and/or other materials provided with the
+// distribution.
+// * Neither the name of Google Inc. nor the names of its
+// contributors may be used to endorse or promote products derived from
+// this software without specific prior written permission.
+//
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+//
+// ---
+// Author: Craig Silverstein
+//
+// A simple program that uses STRIP_FLAG_HELP. We'll have a shell
+// script that runs 'strings' over this program and makes sure
+// that the help string is not in there.
+
+#include "config_for_unittests.h"
+#include
+#define STRIP_FLAG_HELP 1
+#include "gflags/gflags.h"
+
+using GOOGLE_NAMESPACE::SetUsageMessage;
+using GOOGLE_NAMESPACE::ParseCommandLineFlags;
+
+DEFINE_bool(test, true, "This text should be stripped out");
+
+int main(int argc, char** argv) {
+ SetUsageMessage("Usage message");
+ ParseCommandLineFlags(&argc, &argv, false);
+
+ // Unfortunately, for us, libtool can replace executables with a shell
+ // script that does some work before calling the 'real' executable
+ // under a different name. We need the 'real' executable name to run
+ // 'strings' on it, so we construct this binary to print the real
+ // name (argv[0]) on stdout when run.
+ printf("%s\n", argv[0]);
+ return 0;
+}
diff --git a/src/gflags_strip_flags_test.sh b/src/gflags_strip_flags_test.sh
new file mode 100755
index 0000000..d3810db
--- /dev/null
+++ b/src/gflags_strip_flags_test.sh
@@ -0,0 +1,82 @@
+#!/bin/sh
+#
+# Copyright (c) 2011, Google Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# * Redistributions in binary form must reproduce the above
+# copyright notice, this list of conditions and the following disclaimer
+# in the documentation and/or other materials provided with the
+# distribution.
+# * Neither the name of Google Inc. nor the names of its
+# contributors may be used to endorse or promote products derived from
+# this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+# ---
+# Author: Craig Silverstein
+
+if [ -z "$1" ]
+then
+ echo "USAGE: $0 "
+ exit 1
+fi
+
+BINARY="$1"
+
+# Make sure the binary exists...
+if ! "$BINARY" >/dev/null 2>/dev/null
+then
+ echo "Cannot run binary $BINARY"
+ exit 1
+fi
+
+# Make sure the --help output doesn't print the stripped text.
+if "$BINARY" --help | grep "This text should be stripped out" >/dev/null 2>&1
+then
+ echo "Text not stripped from --help like it should be: $BINARY"
+ exit 1
+fi
+
+# Make sure the stripped text isn't in the binary at all.
+if strings --help >/dev/null 2>&1 # make sure the binary exists
+then
+ # Unfortunately, for us, libtool can replace executables with a shell
+ # script that does some work before calling the 'real' executable
+ # under a different name. We need the 'real' executable name to run
+ # 'strings' on it, so we construct this binary to print the real
+ # name (argv[0]) on stdout when run.
+ REAL_BINARY=`"$BINARY"`
+ # On cygwin, we may need to add a '.exe' extension by hand.
+ [ -f "$REAL_BINARY.exe" ] && REAL_BINARY="$REAL_BINARY.exe"
+ if strings "$REAL_BINARY" | grep "This text should be stripped out" >/dev/null 2>&1
+ then
+ echo "Text not stripped from binary like it should be: $BINARY"
+ exit 1
+ fi
+
+ # Let's also do a sanity check to make sure strings is working properly
+ if ! strings "$REAL_BINARY" | grep "Usage message" >/dev/null 2>&1
+ then
+ echo "Usage text not found in binary like it should be: $BINARY"
+ exit 1
+ fi
+fi
+
+echo "PASS"
diff --git a/src/gflags_unittest.cc b/src/gflags_unittest.cc
index 430d062..d10f2c5 100644
--- a/src/gflags_unittest.cc
+++ b/src/gflags_unittest.cc
@@ -1162,7 +1162,8 @@ TEST(DeprecatedFunctionsTest, AppendFlagsIntoFile) {
FILE* fp = fopen(filename.c_str(), "r");
EXPECT_TRUE(fp != NULL);
char line[8192];
- fgets(line, sizeof(line)-1, fp); // first line should be progname
+ EXPECT_TRUE(fgets(line, sizeof(line)-1, fp) != NULL); // get the first line
+ // First line should be progname.
EXPECT_STREQ("not the real argv0\n", line);
bool found_bool = false, found_int32 = false;
diff --git a/src/windows/gflags/gflags.h b/src/windows/gflags/gflags.h
index c7fd423..fdafe2a 100644
--- a/src/windows/gflags/gflags.h
+++ b/src/windows/gflags/gflags.h
@@ -416,7 +416,7 @@ extern GFLAGS_DLL_DECL uint32 ReparseCommandLineNonHelpFlags();
// access flags are quiescent. Referencing flags after this is called
// will have unexpected consequences. This is not safe to run when
// multiple threads might be running: the function is thread-hostile.
-extern void ShutDownCommandLineFlags();
+extern GFLAGS_DLL_DECL void ShutDownCommandLineFlags();
// --------------------------------------------------------------------
@@ -575,16 +575,13 @@ inline clstring* dont_pass0toDEFINE_string(char *stringspot,
int value);
} // namespace fLS
-#define DECLARE_string(name) namespace fLS { extern ::fLS::clstring& FLAGS_##name; } \
+#define DECLARE_string(name) namespace fLS { extern GFLAGS_DLL_DECLARE_FLAG ::fLS::clstring& FLAGS_##name; } \
using fLS::FLAGS_##name
// We need to define a var named FLAGS_no##name so people don't define
// --string and --nostring. And we need a temporary place to put val
// so we don't have to evaluate it twice. Two great needs that go
// great together!
-// The weird 'using' + 'extern' inside the fLS namespace is to work around
-// an unknown compiler bug/issue with the gcc 4.2.1 on SUSE 10. See
-// http://code.google.com/p/google-gflags/issues/detail?id=20
#define DEFINE_string(name, val, txt) \
namespace fLS { \
using ::fLS::clstring; \
@@ -595,9 +592,7 @@ inline clstring* dont_pass0toDEFINE_string(char *stringspot,
static ::google::FlagRegisterer o_##name( \
#name, "string", MAYBE_STRIPPED_HELP(txt), __FILE__, \
s_##name[0].s, new (s_##name[1].s) clstring(*FLAGS_no##name)); \
- extern clstring& FLAGS_##name; \
- using fLS::FLAGS_##name; \
- clstring& FLAGS_##name = *FLAGS_no##name; \
+ GFLAGS_DLL_DEFINE_FLAG clstring& FLAGS_##name = *FLAGS_no##name; \
} \
using fLS::FLAGS_##name